#include "common.h"
#include "icmptunnel.h"

u_char xoutpack[MAX_PACKET_LEN] ;
int datalen=DEFDATALEN ;
struct sockaddr whereto ;
/* u_char *outpack_clean = outpack ; */




int icmp_tunnel_send (int s, u_char *data, int buflen)	/* encodes *data in an icmp paket and sends it */
{
   int r = 0 ; 
   
   r = send_to_socket(s, data, buflen) ;
   /* add encaps code here */
   
   return r ; 
}


int icmp_tunnel_recv (int s, u_char *data) 		/* decodes icmp paket and returns the tunneled data in *data */
{
   int r = 0 ;
   
   r = read_from_socket(s, data) ;
   /* add de-encapsulation code here */

   return r; 
}


int icmp_recv (int s, u_char *rdata)
{
   int r = 0 ;
   int fromlen = 0 ;
   int hlen = 0 ;
   int16_t rtunnel_id = 0 ; 
   int8_t rpoll_key = 0 ;
   int data_offset = 0 ; 
   struct icmphdr *icp ;
   struct iphdr *ip ;
   struct sockaddr lpeer ;
   u_char *data ;
   
   data = (u_char *) malloc(READ_BUF_LEN + 1) ; 
   
   if (!memcpy(&lpeer, &peer, sizeof(struct sockaddr)))
     die("icmp_recv: memcpy(&lpeer, &peer) failed") ;
   
   

   fromlen = sizeof(struct sockaddr) ;
   
   
   r = recvfrom(s, data, READ_BUF_LEN, 0, &lpeer, &fromlen) ;
	   if (r<0) die("icmp_recv: recvfrom(2)") ;

   fprintf(stderr, "icmp_recv:\t\tRead %i bytes from socket %i\n", r, s) ; 

   ip = (struct iphdr *) data ;
   hlen = ip->ip_hl << 2 ;

   if (r < (datalen + ICMP_MINLEN)) 
      fprintf(stderr, "icmp_recv:"
	      		"\t\tWARNING: packet too short, just %i bytes "
	      		"(should be > %i). (discard)\n", 
	      		r, 
	      		((datalen + ICMP_MINLEN)-1)) ;
   

   
   
   icp = (struct icmphdr *) (data + hlen)  ;

   rtunnel_id = ntohs(((int16_t *)icp->icmp_data)[0]);

   if (sockets[s].poll_mode) {
      rpoll_key = (int8_t)((int8_t *)icp->icmp_data)[2] ;
      data_offset = sizeof(sockets[s].tunnel_id) + sizeof(rpoll_key) ;
   } else
     data_offset = sizeof(sockets[s].tunnel_id) ; 
   
      
		   
			 

   
   /* validity checks .. */
   
   /* check wether the 2 id bytes in the packets match our remote id, if not: drop */
   if (rtunnel_id != sockets[s].tunnel_rid) {
      fprintf(stderr, "icmp_recv:\t\t"
    			"tunnel id does not match, this might be a kernel reply. "
    			"(got %hd, want %hd). (discard)\n",
    			rtunnel_id, 
    			sockets[s].tunnel_rid) ;
      return 0 ;
   }

   
   /* check wether the icmp_type matches our recv_type .. if not: drop */
   if (icp->icmp_type != sockets[s].tunnel_recv_type) { 
      fprintf(stderr, "icmp_recv:\t\t"
	      		"receive policy mismatch. "
	      		"(got %s, want %s) (discard)\n", 
	      		print_icmptype_const(icp->icmp_type), 
	      		print_icmptype_const(sockets[s].tunnel_recv_type)) ;
      return 0 ;
   }
   

   if (sockets[s].poll_mode) { /* check poll key */

      /* FIXME: Add code so that clients will drop client replies, and servers will drop Server Polls */
	
      if (rpoll_key & POLLPROT_SPOLL) { /* Server Poll (we must be the client :) */
	 sockets[s].poll_got_spoll = 1 ;
	 sockets[s].icmp_seq_val = icp->icmp_seq ;
	 sockets[s].icmp_id_val = icp->icmp_id ;
	 
	 if (rpoll_key & POLLPROT_DATA)   /* Server Poll with data .. I like that, not wasting any bandwidth :) */
	   fprintf(stderr, "icmp_recv:\t\tPOLLPROT_SPOLL "
		    	    "POLLPROT_DATA (Server Poll with data).\n") ;
	 else {
	    fprintf(stderr, "icmp_recv:\t\tPOLLPROT_SPOLL: "
		    	    "POLLPROT_DATA not set (Server Poll without data). packet discarded\n") ;
	    return 0 ;
	 }
         
	    
	    
      } else 
      if (rpoll_key & POLLPROT_CREPLY) { /* Client Reply (we must be the server ..:) */
	 fprintf(stderr, "icmp_recv:\t\trpoll_key=%d\n", rpoll_key) ;
	 
	 if (rpoll_key & POLLPROT_DATA)	   /* Client has data.. good client */
	   fprintf(stderr, "icmp_recv:\t\tPOLLPROT_CREPLY: "
		   	   "POLLPROT_DATA (Client has data)\n") ;
	 else {
	    fprintf(stderr, "icmp_recv:\t\tPOLLPROT_CREPLY: "
			    "POLLPROT_DATA not set (Client has no data). (packet discarded)\n") ;
            return 0 ;
	 }
	    
	 
	 if (rpoll_key & POLLPROT_MORE_DATA) /* Client has data .. and data on the stack */
	   fprintf(stderr, "icmp_recv:\t\tPOLLPROT_CREPLY: "
		   	   "POLLPROT_MORE_DATA (Client has data, and more on the stack. "
		   	   "Wont do anything about that thou.)") ;
	 

      } /* if (rpoll_key & POLLPROT_CREPLY) */
      

   }

   
   memcpy(rdata, ((u_char *)icp->icmp_data)+data_offset, r - IPHDR_LEN - ICMPHDR_LEN - data_offset) ;
   
	/* segfault debugging prohibits us from printing all this with just one fprintf() */
#ifdef DEBUG
   fprintf(stderr, "icmp_recv:\t\ticp->*\n") ;
   fprintf(stderr, "\t\t\t\ticmp_type=%i (%s)\n", icp->icmp_type, print_icmptype_const(icp->icmp_type)) ;
   fprintf(stderr, "\t\t\t\ticmp_id=%i\n", icp->icmp_id) ;
   fprintf(stderr, "\t\t\t\ticmp_seq=%i\n", icp->icmp_seq) ;
   fprintf(stderr, "\t\t\t\ticmp_code=%i\n", icp->icmp_code) ;
   fprintf(stderr, "\t\t\t\ticmp_cksum=%i\n", icp->icmp_cksum) ; 
/*   fprintf(stderr, "\t\t\t\ticmp_data(>rdata)(len=%i)(ptr=%p)='%s'\n", (r - IPHDR_LEN - ICMPHDR_LEN), rdata, rdata) ; */
   fprintf(stderr, "\t\t\t;\n") ; 
#endif
   


   
   return (r - IPHDR_LEN - ICMPHDR_LEN - data_offset) ;
   
   
   
}

int icmp_send (int s, u_char *data, int buflen)
{
   int r = 0 ;
   int plen = 0 ;
   int data_offset = 0 ;
   register struct icmphdr *icp ;
   struct sockaddr_in *tpeer ;
   u_char outpack[MAX_PACKET_LEN];
   tpeer = (struct sockaddr_in *) &peer ;
/*   bzero(&outpack, MAX_PACKET_LEN) ; */
   
   
   
   
   
   icp = (struct icmphdr *) outpack ;

   /* build the icmp header */
   icp->icmp_type = sockets[s].tunnel_send_type ;
   icp->icmp_cksum = 0 ;
   
   /* if we're in poll client mode and we've fetched icmp_seq and icmp_id from a
    * received packet, use it in this one. */

   if ((sockets[s].poll_mode == POLLMODE_CLIENT) &&
       sockets[s].icmp_seq_val &&
       sockets[s].icmp_id_val) {

      icp->icmp_id = sockets[s].icmp_id_val ;
      icp->icmp_seq = sockets[s].icmp_seq_val ;
   } else {
      icp->icmp_id = getpid() & 0xFFFF;
      icp->icmp_seq = rand()%(50000-2000)+2000 ;
   }
   
   if (sockets[s].poll_mode) 
      if (buflen>0) /* if theres data to be sent, OR it into the key */
	sockets[s].poll_key |= POLLPROT_DATA ;
      else
        sockets[s].poll_key &= ~POLLPROT_DATA ;
	

   /* insert our id into the pack */
   ((int16_t *)icp->icmp_data)[0] = htons(sockets[s].tunnel_id) ;

   /* if we're polling, insert the pollmode byte before the data 
    * (at byte offset 2 (byte #3 that is) */
   
   if (sockets[s].poll_mode) { 
      fprintf(stderr, "icmp_send:\t\t"
	      	      "stuffed the sockets[%i].poll_key (%d) byte " 
	       	      "into icmp_data at offset 2\n",
	      	      s, 
	      	      sockets[s].poll_key) ;

      data_offset = sizeof(sockets[s].tunnel_id) + sizeof(sockets[s].poll_key) ;
      ((int8_t *)icp->icmp_data)[2] = sockets[s].poll_key ;
    
   } else
     data_offset = sizeof(sockets[s].tunnel_id) ; 
   
   fprintf(stderr, "icmp_send:\t\tpre memcpy(). data_offset=%i\n", data_offset) ; 
   memcpy(((u_char *)icp->icmp_data)+data_offset, data, buflen) ;
   
   plen = 8 + buflen + data_offset ;
   
   

   icp->icmp_cksum = in_cksum((u_short *)icp, plen) ;

   fprintf(stderr, "icmp_send:\t\t"
	   	   "plen=%i buflen=%i icmp_cksum=%i icmp_type=%s to=%s\n", 
	   	    plen, 
	            buflen, 
	            icp->icmp_cksum, 
	            print_icmptype_const(icp->icmp_type), 
	            inet_ntoa(tpeer->sin_addr));

#ifdef DEBUG
      fprintf(stderr, "icmp_send:\t\ticp->*\n") ;
      fprintf(stderr, "\t\t\t\ticmp_type=%i (%s)\n", icp->icmp_type, print_icmptype_const(icp->icmp_type)) ;
      fprintf(stderr, "\t\t\t\ticmp_id=%i\n", icp->icmp_id) ;
      fprintf(stderr, "\t\t\t\ticmp_seq=%i\n", icp->icmp_seq) ;
      fprintf(stderr, "\t\t\t\ticmp_code=%i\n", icp->icmp_code) ;
      fprintf(stderr, "\t\t\t\ticmp_cksum=%i\n", icp->icmp_cksum) ; 
/*      fprintf(stderr, "\t\t\t\ticmp_data='%s'\n", icp->icmp_data) ; */
      fprintf(stderr, "\t\t\t;\n") ;
#endif

   
   r = sendto(s, (char *)outpack, plen, 0, &peer, sizeof(struct sockaddr)) ;


   if (r<0) 
     die("icmp_send: sendto(2)") ;
   
   fprintf(stderr, "icmp_send:\t\tSent %i bytes on socket %i\n", r, s) ;
   
   return r ;
}


int setup_icmp_socket (int s, int recv_type, int send_type, int16_t tunnel_id, int16_t tunnel_rid)
{
   if (sockets[s].type == IPPROTO_ICMP) {
      sockets[s].tunnel_send = *icmp_tunnel_send ; 
      sockets[s].tunnel_recv = *icmp_tunnel_recv ;
      sockets[s].recv = *icmp_recv ;
      sockets[s].send = *icmp_send ; 
      sockets[s].tunnel_send_type = send_type ;
      sockets[s].tunnel_recv_type = recv_type ;
      sockets[s].tunnel_id = tunnel_id ; 
      sockets[s].tunnel_rid = tunnel_rid ; /* drop packets not having this rtunnel_id */
      sockets[s].istunnel = 1 ;

      
      
      fprintf(stderr, "setup_icmp_socket:\tProtocol dependent tunneling code setup for socket %i.\n", s) ;
      return 1 ;
      
   } else {
      fprintf(stderr, "setup_icmp_socket:\tWARNING: Cannot use setup_icmp_socket() on non-ICMP socket %i\n", s) ;
      return -1 ;
      
   }
   
}

char *print_icmptype_const (int icmp_type)
{
   char *icmp_desc ; 
   
   icmp_desc = (char *) malloc(32) ; /* a 31 byte description should be enuff */
   
   
   switch (icmp_type) {
    case ICMP_ECHOREPLY:
      sprintf(icmp_desc, "ICMP_ECHOREPLY") ;
      break ;
    case ICMP_DEST_UNREACH:
      sprintf(icmp_desc, "ICMP_DEST_UNREACH") ;
      break ;
    case ICMP_SOURCE_QUENCH:
      sprintf(icmp_desc, "ICMP_SOURCE_QUENCH") ;
      break ;
    case ICMP_REDIRECT:
      sprintf(icmp_desc, "ICMP_REDIRECT") ; 
      break ;
    case ICMP_ECHO:
      sprintf(icmp_desc, "ICMP_ECHO") ; 
      break ; 
    case ICMP_TIME_EXCEEDED:
      sprintf(icmp_desc, "ICMP_TIME_EXCEEDED") ;
      break ;
    case ICMP_PARAMETERPROB:
      sprintf(icmp_desc, "ICMP_PARAMETERPROB") ;
      break ;
    case ICMP_TIMESTAMP:
      sprintf(icmp_desc, "ICMP_TIMESTAMP") ;
      break ;
    case ICMP_TIMESTAMPREPLY:
      sprintf(icmp_desc, "ICMP_TIMESTAMPREPLY") ;
      break ;
    case ICMP_INFO_REQUEST:
      sprintf(icmp_desc, "ICMP_INFO_REQUEST") ;
      break ;
    case ICMP_INFO_REPLY:
      sprintf(icmp_desc, "ICMP_INFO_REPLY") ;
      break ;
    case ICMP_ADDRESS:
      sprintf(icmp_desc, "ICMP_ADDRESS") ;
      break ;
    case ICMP_ADDRESSREPLY:
      sprintf(icmp_desc, "ICMP_ADDRESSREPLY") ;
      break ;
    default:
      sprintf(icmp_desc, "(unknown)") ;
      break ;
   }
   
   return icmp_desc ;
}

int icmptype_const_to_int (const char *icmptype_const)
{
   if (strcmp(icmptype_const, "ICMP_ECHOREPLY")==0)
     return ICMP_ECHOREPLY ;
   if (strcmp(icmptype_const, "ICMP_ECHO")==0)
     return ICMP_ECHO ;
   if (strcmp(icmptype_const, "ICMP_DEST_UNREACH")==0)
     return ICMP_DEST_UNREACH ;
   else
     return -1 ;
   
   /*

 case ICMP_DEST_UNREACH:
         sprintf(icmp_desc, "ICMP_DEST_UNREACH") ;
         break ;
 case ICMP_SOURCE_QUENCH:
         sprintf(icmp_desc, "ICMP_SOURCE_QUENCH") ;
         break ;
 case ICMP_REDIRECT:
         sprintf(icmp_desc, "ICMP_REDIRECT") ;
         break ;
 case ICMP_ECHO:
         sprintf(icmp_desc, "ICMP_ECHO") ;
         break ;
 case ICMP_TIME_EXCEEDED:
         sprintf(icmp_desc, "ICMP_TIME_EXCEEDED") ;
         break ;
 case ICMP_PARAMETERPROB:
         sprintf(icmp_desc, "ICMP_PARAMETERPROB") ;
         break ;
 case ICMP_TIMESTAMP:
         sprintf(icmp_desc, "ICMP_TIMESTAMP") ;
         break ;
 case ICMP_TIMESTAMPREPLY:
         sprintf(icmp_desc, "ICMP_TIMESTAMPREPLY") ;
         break ;
 case ICMP_INFO_REQUEST:
         sprintf(icmp_desc, "ICMP_INFO_REQUEST") ;
         break ;
 case ICMP_INFO_REPLY:
         sprintf(icmp_desc, "ICMP_INFO_REPLY") ;
         break ;
 case ICMP_ADDRESS:
         sprintf(icmp_desc, "ICMP_ADDRESS") ;
         break ;
 case ICMP_ADDRESSREPLY:
         sprintf(icmp_desc, "ICMP_ADDRESSREPLY") ;
         break ;
 default:
         sprintf(icmp_desc, "(unknown)") ;
         break ;
   
   */
   
   
   
   
}

    
   



int in_cksum(u_short *addr, int len)
{
           register int nleft = len;
           register u_short *w = addr;
           register int sum = 0;
           u_short answer = 0;
   
           /*
	    *          * Our algorithm is simple, using a 32 bit accumulator (sum), we add
	    *          * sequential 16 bit words to it, and at the end, fold back all the
	    *          * carry bits from the top 16 bits into the lower 16 bits.
	    *          */
           while (nleft > 1)  {
	                      sum += *w++;
	                      nleft -= 2;
	   }
   
           /* mop up an odd byte, if necessary */
           if (nleft == 1) {
	                      *(u_char *)(&answer) = *(u_char *)w ;
	                      sum += answer;
	   }
   
           /* add back carry outs from top 16 bits to low 16 bits */
           sum = (sum >> 16) + (sum & 0xffff);     /* add hi 16 to low 16 */
           sum += (sum >> 16);                     /* add carry */
           answer = ~sum;                          /* truncate to 16 bits */
           return(answer);
}
